.386 
.model flat, stdcall  ;32 bit memory model 
option casemap :none  ;case sensitive 

include C:\masm32\include\windows.inc 
include C:\masm32\include\kernel32.inc 
include C:\masm32\include\user32.inc 
include C:\masm32\include\gdi32.inc
include C:\masm32\include\ole32.inc
includelib C:\masm32\lib\kernel32.lib 
includelib C:\masm32\lib\user32.lib 
includelib C:\masm32\lib\gdi32.lib 
includelib C:\masm32\lib\ole32.lib

DlgProc		PROTO   :HWND,:UINT,:WPARAM,:LPARAM 
IDD_DIALOG1	equ 101

.data
; Variables used for TestDLL.dll
LibName db "TestDLL.dll",0 
FunctionName db "ShowTab",0 
DllNotFound db "Cannot load library",0 
FunctionNotFound db "ShowTab function not found",0
AppName db "Test",0


.data?
hInstance dd ?

; Variables used for TestDLL.dll
hLib dd ?
ShowTabAddr dd ?

.code 
start: 
   invoke GetModuleHandle,NULL 
   mov hInstance,eax 
   invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
   invoke ExitProcess,0 

; UXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXUXU

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
 
	.if uMsg==WM_INITDIALOG 
		invoke LoadLibrary,addr LibName  
        	.if eax==NULL 
                	invoke MessageBox,NULL,addr DllNotFound,addr AppName,MB_OK
                	invoke SendMessage, hWin, WM_CLOSE, 0, 0
        	.else 
                	mov hLib,eax 
                	invoke GetProcAddress,hLib,addr FunctionName
                	.if eax==NULL 
                        	invoke MessageBox,NULL,addr FunctionNotFound,addr AppName,MB_OK 
                	.else 
                        	mov ShowTabAddr,eax   
                        	
                        	; Call ShowTab function.
                        	push FALSE
				push hWin
				call [ShowTabAddr]
                	.endif
                .endif

   	.elseif uMsg==WM_CLOSE
   		invoke KillTimer, hWin, 0
      		invoke FreeLibrary,hLib
      		invoke EndDialog,hWin,0 

   	.else 
      		xor eax,eax
      		ret  
   	.endif 
	
	mov eax,TRUE 
	ret 

DlgProc endp 

end start